// Enums.h

#pragma once
#include "resource.h"       // main symbols


[export]
typedef enum SvnWcSchedule
{
  SvnWcScheduleNormal,
  SvnWcScheduleAdd,
  SvnWcScheduleDelete,
  SvnWcScheduleReplace
} SvnWcSchedule;

[export]
typedef enum SvnWcNotifyState
{
	SvnWcNotifyStateInapplicable = 0,
	SvnWcNotifyStateUnknown,
	SvnWcNotifyStateUnchanged,
	SvnWcNotifyStateMissing,
	SvnWcNotifyStateObstructed,
	SvnWcNotifyStateChanged,
	SvnWcNotifyStateMerged,
	SvnWcNotifyStateConflicted
} SvnWcNotifyState;

[export]
typedef enum SvnWcNotifyAction
{
  SvnWcNotifyActionAdd = 0,
  SvnWcNotifyActionCopy,
  SvnWcNotifyActionDelete,
  SvnWcNotifyActionRestore,
  SvnWcNotifyActionRevert,
  SvnWcNotifyActionFailedRevert,
  SvnWcNotifyActionResolved,
  SvnWcNotifyActionSkip,
  SvnWcNotifyActionUpdateDelete,
  SvnWcNotifyActionUpdateAdd,
  SvnWcNotifyActionUpdateUpdate,
  SvnWcNotifyActionUpdateCompleted,
  SvnWcNotifyActionUpdateExternal,
  SvnWcNotifyActionStatusCompleted,
  SvnWcNotifyActionstatus_external,
  SvnWcNotifyActionCommitModified,
  SvnWcNotifyActionCommitAdded,
  SvnWcNotifyActionCommitDeleted,
  SvnWcNotifyActionCommitReplaced,
  SvnWcNotifyActionCommitPostfixTxdelta,
  SvnWcNotifyActionBlameRevision,
  SvnWcNotifyActionLocked,
  SvnWcNotifyActionUnlocked,
  SvnWcNotifyActionFailedLock,
  SvnWcNotifyActionFailedUnlock
} SvnWcNotifyAction;

[export]
typedef enum SvnNodeKind
{
  SvnNodeKindNone = 0,
  SvnNodeKindFile,
  SvnNodeKindDir,
  SvnNodeKindUnknown
} SvnNodeKind;

[export]
typedef enum SvnWcNotifyLockState {
  SvnWcNotifyLockStateInapplicable = 0,
  SvnWcNotifyLockStateUnknown,
  SvnWcNotifyLockStateUnchanged,
  SvnWcNotifyLockStateLocked,
  SvnWcNotifyLockStateUnlocked
} SvnWcNotifyLockState;

[export]
typedef enum SvnWcStatusKind
{
    SvnWcStatusKindNone = 1,
    SvnWcStatusKindUnversioned,
    SvnWcStatusKindNormal,
    SvnWcStatusKindAdded,
    SvnWcStatusKindMissing,
    SvnWcStatusKindDeleted,
    SvnWcStatusKindReplaced,
    SvnWcStatusKindModified,
    SvnWcStatusKindMerged,
    SvnWcStatusKindConflicted,
    SvnWcStatusKindIgnored,
    SvnWcStatusKindObstructed,
    SvnWcStatusKindExternal,
    SvnWcStatusKindIncomplete
}SvnWcStatusKind;