// Copyright (C) 2006 Pushok Software http://www.pushok.com/soft_svncom.php
//
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//
// Subversion is Copyrght of(c) 2000-2004 CollabNet.  All rights reserved.
// Full license available here http://subversion.tigris.org/license-1.html.

#pragma once
#include "resource.h"       // main symbols

#include "pcom.h"

// CSVNLock

class ATL_NO_VTABLE CSVNLock : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CSVNLock, &CLSID_SVNLock>,
	public ISupportErrorInfo,
	public IDispatchImpl<ISVNLock, &IID_ISVNLock, &LIBID_PushOkSvn, /*wMajor =*/ 1, /*wMinor =*/ 0>
{
public:
	CSVNLock()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_SVNLOCK)

BEGIN_COM_MAP(CSVNLock)
	COM_INTERFACE_ENTRY(ISVNLock)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

	DECLARE_PROTECT_FINAL_CONSTRUCT()
	DECLARE_GET_CONTROLLING_UNKNOWN()

	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}
	
	void FinalRelease() 
	{
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

private:
	CComBSTR path;              /**< the path this lock applies to */
	CComBSTR token;             /**< unique URI representing lock */
	CComBSTR owner;             /**< the username which owns the lock */
	CComBSTR comment;           /**< (optional) description of lock  */
	BOOL is_dav_comment;		/**< was comment made by generic DAV client? */
	CY creation_date;			/**< when lock was made */
	CY expiration_date;			/**< (optional) when lock will expire;
                                      If value is 0, lock will never expire. */
// ISVNLock
public:
	STDMETHOD(put_Path)(BSTR sVal) {
		LOCK_THIS_OBJ
		path = sVal;
		return S_OK;
	}
	STDMETHOD(get_Path)(BSTR* psVal) {
		LOCK_THIS_OBJ
		return path.CopyTo(psVal);
	}

	STDMETHOD(put_Token)(BSTR sVal) {
		LOCK_THIS_OBJ
		token = sVal;
		return S_OK;
	}
	STDMETHOD(get_Token)(BSTR* psVal) {
		LOCK_THIS_OBJ
		return token.CopyTo(psVal);
	}

	STDMETHOD(put_Owner)(BSTR sVal) {
		LOCK_THIS_OBJ
		owner = sVal;
		return S_OK;
	}
	STDMETHOD(get_Owner)(BSTR* psVal) {
		LOCK_THIS_OBJ
		return owner.CopyTo(psVal);
	}

	STDMETHOD(put_Comment)(BSTR sVal) {
		LOCK_THIS_OBJ
		comment = sVal;
		return S_OK;
	}
	STDMETHOD(get_Comment)(BSTR* psVal) {
		LOCK_THIS_OBJ
		return comment.CopyTo(psVal);
	}

	STDMETHOD(put_IsDavComment)(BOOL blVal) {
		LOCK_THIS_OBJ
		is_dav_comment = blVal;
		return S_OK;
	}
	STDMETHOD(get_IsDavComment)(BOOL* pblVal) {
		if (!pblVal)
			return E_INVALIDARG;
		LOCK_THIS_OBJ
		*pblVal = is_dav_comment;
		return S_OK;
	}


	STDMETHOD(put_CreationDate)(CY cyVal) {
		LOCK_THIS_OBJ
		creation_date = cyVal;
		return S_OK;
	}
	STDMETHOD(get_CreationDate)(CY* pcyVal) {
		if (!pcyVal)
			return E_INVALIDARG;
		LOCK_THIS_OBJ
		*pcyVal = creation_date;
		return S_OK;
	}


	STDMETHOD(put_ExpirationDate)(CY cyVal) {
		LOCK_THIS_OBJ
		expiration_date = cyVal;
		return S_OK;
	}
	STDMETHOD(get_ExpirationDate)(CY* pcyVal) {
		if (!pcyVal)
			return E_INVALIDARG;
		LOCK_THIS_OBJ
        *pcyVal = expiration_date;
		return S_OK;
	}

};

OBJECT_ENTRY_AUTO(__uuidof(SVNLock), CSVNLock)
