// Copyright (C) 2006 Pushok Software http://www.pushok.com/soft_svncom.php
//
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//
// Subversion is Copyrght of(c) 2000-2004 CollabNet.  All rights reserved.
// Full license available here http://subversion.tigris.org/license-1.html.

#pragma once
#include "resource.h"       // main symbols

#include "pcom.h"

// CSVNWcAnn

class ATL_NO_VTABLE CSVNWcAnn : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CSVNWcAnn, &CLSID_SVNWcAnn>,
	public ISupportErrorInfo,
	public IDispatchImpl<ISVNWcAnn, &IID_ISVNWcAnn, &LIBID_PushOkSvn, /*wMajor =*/ 1, /*wMinor =*/ 0>
{
public:
	CSVNWcAnn()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_SVNWCANN)

BEGIN_COM_MAP(CSVNWcAnn)
	COM_INTERFACE_ENTRY(ISVNWcAnn)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

	DECLARE_PROTECT_FINAL_CONSTRUCT()
	DECLARE_GET_CONTROLLING_UNKNOWN()

	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}
	
	void FinalRelease() 
	{
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

private:
	LONG     m_revition;
    CY		 m_line_no;
	CComBSTR m_author;
	CComBSTR m_date;
	CComBSTR m_line;

// ISVNWcAnn
public:
	STDMETHOD(put_Rev)(LONG lVal) {
		LOCK_THIS_OBJ
		m_revition = lVal;
		return S_OK;
	}
	STDMETHOD(get_Rev)(LONG* plVal) {
		if (!plVal)
			return E_INVALIDARG;
		LOCK_THIS_OBJ
        *plVal = m_revition;
		return S_OK;
	}

	STDMETHOD(put_Author)(BSTR sVal) {
		LOCK_THIS_OBJ
		m_author = sVal;
		return S_OK;
	}
	STDMETHOD(get_Author)(BSTR* psVal) {
		LOCK_THIS_OBJ
		return m_author.CopyTo(psVal);
	}

	STDMETHOD(put_Date)(BSTR sVal) {
		LOCK_THIS_OBJ
		m_date = sVal;
		return S_OK;
	}
	STDMETHOD(get_Date)(BSTR* psVal) {
		LOCK_THIS_OBJ
		return m_date.CopyTo(psVal);
	}

	STDMETHOD(put_Line)(BSTR sVal) {
		LOCK_THIS_OBJ
		m_line = sVal;
		return S_OK;
	}
	STDMETHOD(get_Line)(BSTR* psVal) {
		LOCK_THIS_OBJ
		return m_line.CopyTo(psVal);
	}

	STDMETHOD(put_LineNo)(CY cyVal) {
		LOCK_THIS_OBJ
		m_line_no = cyVal;
		return S_OK;
	}
	STDMETHOD(get_LineNo)(CY* pcyVal) {
		if (!pcyVal)
			return E_INVALIDARG;
		LOCK_THIS_OBJ
        *pcyVal = m_line_no;
		return S_OK;
	}

};

OBJECT_ENTRY_AUTO(__uuidof(SVNWcAnn), CSVNWcAnn)

namespace PushokAtlEx
{
	template <>
	class GenericCopy< VARIANT, ISVNWcAnn* >
	{
	public :
		static void init(VARIANT* p)
		{
			GenericCopy<VARIANT>::init(p);
		}
		static void destroy(VARIANT* p)
		{
			GenericCopy<VARIANT>::destroy(p);
		}
		static HRESULT copy( VARIANT *pTo, ISVNWcAnn* *pFrom)
		{
			CComVariant vt((IDispatch *)*pFrom);
			return vt.Detach(pTo);
			return S_OK;
		}
	}; // class GenericCopy<VARIANT, ISVNWcNotify* pVal>
}

namespace SVNWcAnnVector_
{
	// Store our data in a vector of std::strings
	typedef std::vector< PushokAtlEx::CComPtrAdapt< ISVNWcAnn> >					ContainerType;

	// Now we have all the information we need to fill in the template arguments on the implementation classes
	typedef CComEnumOnSTL< IEnumVARIANT, &__uuidof(IEnumVARIANT), VARIANT,
							PushokAtlEx::GenericCopy< VARIANT, ISVNWcAnn* >, ContainerType > EnumeratorType;

	typedef ICollectionOnSTLImpl< ISVNWcAnnVector, ContainerType, ISVNWcAnn*,
							_CopyInterface<ISVNWcAnn>, EnumeratorType > CollectionType;
};

class ATL_NO_VTABLE CSVNWcAnnVector : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CSVNWcAnnVector, &CLSID_SVNWcAnnVector>,
	public IDispatchImpl<SVNWcAnnVector_::CollectionType,&__uuidof(ISVNWcAnnVector)>
{
public:
	CSVNWcAnnVector()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_SVNWCANNVECTOR)

BEGIN_COM_MAP(CSVNWcAnnVector)
	COM_INTERFACE_ENTRY(ISVNWcAnnVector)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
END_COM_MAP()


	DECLARE_PROTECT_FINAL_CONSTRUCT()
	DECLARE_GET_CONTROLLING_UNKNOWN()

	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}
	
	void FinalRelease() 
	{
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

public:
	STDMETHOD(Add)(ISVNWcAnn* pVal) {
		LOCK_THIS_OBJ
		m_coll.push_back(pVal);
		return S_OK;
	}
	STDMETHOD(Remove) (long Index) {
		LOCK_THIS_OBJ
		try {
			m_coll.erase(m_coll.begin() + Index);
		} catch(...) {
			return E_FAIL;
		}
		return S_OK;
	}
};

OBJECT_ENTRY_AUTO(__uuidof(SVNWcAnnVector), CSVNWcAnnVector)