// Copyright (C) 2006 Pushok Software http://www.pushok.com/soft_svncom.php
//
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//
// Subversion is Copyrght of(c) 2000-2004 CollabNet.  All rights reserved.
// Full license available here http://subversion.tigris.org/license-1.html.

#pragma once
#include "resource.h"       // main symbols

#include "pcom.h"

// CSVNWcInfo

class ATL_NO_VTABLE CSVNWcInfo : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CSVNWcInfo, &CLSID_SVNWcInfo>,
	public ISupportErrorInfo,
	public IDispatchImpl<ISVNWcInfo, &IID_ISVNWcInfo, &LIBID_PushOkSvn, /*wMajor =*/ 1, /*wMinor =*/ 0>
{
public:
	CSVNWcInfo()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_SVNWCINFO)

BEGIN_COM_MAP(CSVNWcInfo)
	COM_INTERFACE_ENTRY(ISVNWcInfo)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

	DECLARE_PROTECT_FINAL_CONSTRUCT()
	DECLARE_GET_CONTROLLING_UNKNOWN()

	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}
	
	void FinalRelease() 
	{
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

public:
	STDMETHOD(put_Url)(BSTR newVal) {
		LOCK_THIS_OBJ
		m_Url = newVal;
		return S_OK;
	}
	STDMETHOD(get_Url)(BSTR* pVal) {
		LOCK_THIS_OBJ
		return m_Url.CopyTo(pVal);
	}

	STDMETHOD(put_ReposRootUrl)(BSTR newVal) {
		LOCK_THIS_OBJ
		m_ReposRootUrl = newVal;
		return S_OK;
	}
	STDMETHOD(get_ReposRootUrl)(BSTR* pVal) {
		LOCK_THIS_OBJ
		return m_ReposRootUrl.CopyTo(pVal);
	}

	STDMETHOD(put_ReposUUID)(BSTR newVal) {
		LOCK_THIS_OBJ
		m_ReposUUID = newVal;
		return S_OK;
	}
	STDMETHOD(get_ReposUUID)(BSTR* pVal) {
		LOCK_THIS_OBJ
		return m_ReposUUID.CopyTo(pVal);
	}

	STDMETHOD(put_LastChangedAuthor)(BSTR newVal) {
		LOCK_THIS_OBJ
		m_LastChangedAuthor = newVal;
		return S_OK;
	}
	STDMETHOD(get_LastChangedAuthor)(BSTR* pVal) {
		LOCK_THIS_OBJ
		return m_LastChangedAuthor.CopyTo(pVal);
	}

	STDMETHOD(put_CopyFromUrl)(BSTR newVal) {
		LOCK_THIS_OBJ
		m_CopyFromUrl = newVal;
		return S_OK;
	}
	STDMETHOD(get_CopyFromUrl)(BSTR* pVal) {
		LOCK_THIS_OBJ
		return m_CopyFromUrl.CopyTo(pVal);
	}

	STDMETHOD(put_Checksum)(BSTR newVal) {
		LOCK_THIS_OBJ
		m_Checksum = newVal;
		return S_OK;
	}
	STDMETHOD(get_Checksum)(BSTR* pVal) {
		LOCK_THIS_OBJ
		return m_Checksum.CopyTo(pVal);
	}

	STDMETHOD(put_ConflictOld)(BSTR newVal) {
		LOCK_THIS_OBJ
		m_ConflictOld = newVal;
		return S_OK;
	}
	STDMETHOD(get_ConflictOld)(BSTR* pVal) {
		LOCK_THIS_OBJ
		return m_ConflictOld.CopyTo(pVal);
	}

	STDMETHOD(put_ConflictNew)(BSTR newVal) {
		LOCK_THIS_OBJ
		m_ConflictNew = newVal;
		return S_OK;
	}
	STDMETHOD(get_ConflictNew)(BSTR* pVal) {
		LOCK_THIS_OBJ
		return m_ConflictNew.CopyTo(pVal);
	}

	STDMETHOD(put_ConflictWrk)(BSTR newVal) {
		LOCK_THIS_OBJ
		m_ConflictWrk = newVal;
		return S_OK;
	}
	STDMETHOD(get_ConflictWrk)(BSTR* pVal) {
		LOCK_THIS_OBJ
		return m_ConflictWrk.CopyTo(pVal);
	}

	STDMETHOD(put_PrejFile)(BSTR newVal) {
		LOCK_THIS_OBJ
		m_PrejFile = newVal;
		return S_OK;
	}
	STDMETHOD(get_PrejFile)(BSTR* pVal) {
		LOCK_THIS_OBJ
		return m_PrejFile.CopyTo(pVal);
	}

	STDMETHOD(put_Revision)(LONG newVal) {
		LOCK_THIS_OBJ
		 m_Rev = newVal;
		return S_OK;
	}
	STDMETHOD(get_Revision)(LONG* pVal) {
		if (!pVal)
			return E_INVALIDARG;
		LOCK_THIS_OBJ
		*pVal = m_Rev;
		return S_OK;
	}

	STDMETHOD(put_LastChangedRev)(LONG newVal) {
		LOCK_THIS_OBJ
		 m_LastChangedRev = newVal;
		return S_OK;
	}
	STDMETHOD(get_LastChangedRev)(LONG* pVal) {
		if (!pVal)
			return E_INVALIDARG;
		LOCK_THIS_OBJ
		*pVal = m_LastChangedRev;
		return S_OK;
	}

	STDMETHOD(put_CopyFromRev)(LONG newVal) {
		LOCK_THIS_OBJ
		 m_CopyFromRev = newVal;
		return S_OK;
	}
	STDMETHOD(get_CopyFromRev)(LONG* pVal) {
		if (!pVal)
			return E_INVALIDARG;
		LOCK_THIS_OBJ
		*pVal = m_CopyFromRev;
		return S_OK;
	}

	STDMETHOD(put_HasWcInfo)(BOOL newVal) {
		LOCK_THIS_OBJ
		 m_HasWcInfo = newVal;
		return S_OK;
	}
	STDMETHOD(get_HasWcInfo)(BOOL* pVal) {
		if (!pVal)
			return E_INVALIDARG;
		LOCK_THIS_OBJ
		*pVal = m_HasWcInfo;
		return S_OK;
	}

	STDMETHOD(put_LastChangedDate)(CY newVal) {
		LOCK_THIS_OBJ
		 m_LastChangedDate = newVal;
		return S_OK;
	}
	STDMETHOD(get_LastChangedDate)(CY* pVal) {
		if (!pVal)
			return E_INVALIDARG;
		LOCK_THIS_OBJ
		*pVal = m_LastChangedDate;
		return S_OK;
	}

	STDMETHOD(put_TextTime)(CY newVal) {
		LOCK_THIS_OBJ
		 m_TextTime = newVal;
		return S_OK;
	}
	STDMETHOD(get_TextTime)(CY* pVal) {
		if (!pVal)
			return E_INVALIDARG;
		LOCK_THIS_OBJ
		*pVal = m_TextTime;
		return S_OK;
	}

	STDMETHOD(put_PropTime)(CY newVal) {
		LOCK_THIS_OBJ
		 m_PropTime = newVal;
		return S_OK;
	}
	STDMETHOD(get_PropTime)(CY* pVal) {
		if (!pVal)
			return E_INVALIDARG;
		LOCK_THIS_OBJ
		*pVal = m_PropTime;
		return S_OK;
	}

	STDMETHOD(put_Kind)(SvnNodeKind newVal) {
		LOCK_THIS_OBJ
		 m_Kind = newVal;
		return S_OK;
	}
	STDMETHOD(get_Kind)(SvnNodeKind* pVal) {
		if (!pVal)
			return E_INVALIDARG;
		LOCK_THIS_OBJ
		*pVal = m_Kind;
		return S_OK;
	}

	STDMETHOD(put_Schedule)(SvnWcSchedule newVal) {
		LOCK_THIS_OBJ
		 m_Schedule = newVal;
		return S_OK;
	}
	STDMETHOD(get_Schedule)(SvnWcSchedule* pVal) {
		if (!pVal)
			return E_INVALIDARG;
		LOCK_THIS_OBJ
		*pVal = m_Schedule;
		return S_OK;
	}

	STDMETHOD(put_Path)(BSTR newVal) {
		LOCK_THIS_OBJ
		m_Path = newVal;
		return S_OK;
	}
	STDMETHOD(get_Path)(BSTR* pVal) {
		LOCK_THIS_OBJ
		return m_Path.CopyTo(pVal);
	}

	STDMETHOD(put_Lock)(ISVNLock* pVal) {
		LOCK_THIS_OBJ
		 m_Lock = pVal;
		return S_OK;
	}
	STDMETHOD(get_Lock)(ISVNLock** ppVal) {
		LOCK_THIS_OBJ
		return m_Lock.CopyTo(ppVal);
	}


private:
	CComBSTR		m_Path;
	CComBSTR		m_Url;
	LONG			m_Rev;
	SvnNodeKind		m_Kind;
	CComBSTR		m_ReposRootUrl;
	CComBSTR		m_ReposUUID;
	LONG			m_LastChangedRev;
	CY				m_LastChangedDate;
	CComBSTR		m_LastChangedAuthor;
	CComPtr<ISVNLock> m_Lock;
	BOOL			m_HasWcInfo;
	SvnWcSchedule	m_Schedule;
	CComBSTR		m_CopyFromUrl;
	LONG			m_CopyFromRev;
	CY				m_TextTime;
	CY				m_PropTime;
	CComBSTR		m_Checksum;
	CComBSTR		m_ConflictOld;
	CComBSTR		m_ConflictNew;
	CComBSTR		m_ConflictWrk;
	CComBSTR		m_PrejFile;
};

OBJECT_ENTRY_AUTO(__uuidof(SVNWcInfo), CSVNWcInfo)

namespace PushokAtlEx
{
	template <>
	class GenericCopy< VARIANT, ISVNWcInfo* >
	{
	public :
		static void init(VARIANT* p)
		{
			GenericCopy<VARIANT>::init(p);
		}
		static void destroy(VARIANT* p)
		{
			GenericCopy<VARIANT>::destroy(p);
		}
		static HRESULT copy( VARIANT *pTo, ISVNWcInfo* *pFrom)
		{
			CComVariant vt((IDispatch *)*pFrom);
			return vt.Detach(pTo);
			return S_OK;
		}
	}; // class GenericCopy<VARIANT, ISVNWcNotify* pVal>
}

namespace SVNWcInfoVector_
{
	// Store our data in a vector of std::strings
	typedef std::vector< PushokAtlEx::CComPtrAdapt< ISVNWcInfo> >					ContainerType;

	// Now we have all the information we need to fill in the template arguments on the implementation classes
	typedef CComEnumOnSTL< IEnumVARIANT, &__uuidof(IEnumVARIANT), VARIANT,
							PushokAtlEx::GenericCopy< VARIANT, ISVNWcInfo* >, ContainerType > EnumeratorType;

	typedef ICollectionOnSTLImpl< ISVNWcInfoVector, ContainerType, ISVNWcInfo*,
							_CopyInterface<ISVNWcInfo>, EnumeratorType > CollectionType;
};

class ATL_NO_VTABLE CSVNWcInfoVector : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CSVNWcInfoVector, &CLSID_SVNWcInfoVector>,
	public IDispatchImpl<SVNWcInfoVector_::CollectionType,&__uuidof(ISVNWcInfoVector)>
{
public:
	CSVNWcInfoVector()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_SVNWCINFOVECTOR)

BEGIN_COM_MAP(CSVNWcInfoVector)
	COM_INTERFACE_ENTRY(ISVNWcInfoVector)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY_AGGREGATE(IID_IMarshal, m_pUnkMarshaler.p)
END_COM_MAP()


	DECLARE_PROTECT_FINAL_CONSTRUCT()
	DECLARE_GET_CONTROLLING_UNKNOWN()

	HRESULT FinalConstruct()
	{
		return CoCreateFreeThreadedMarshaler(
			GetControllingUnknown(), &m_pUnkMarshaler.p);
	}
	
	void FinalRelease() 
	{
		m_pUnkMarshaler.Release();
	}

	CComPtr<IUnknown> m_pUnkMarshaler;

public:
	STDMETHOD(Add)(ISVNWcInfo* pVal) {
		LOCK_THIS_OBJ
		m_coll.push_back(pVal);
		return S_OK;
	}
	STDMETHOD(Remove) (long Index) {
		LOCK_THIS_OBJ
		try {
			m_coll.erase(m_coll.begin() + Index);
		} catch(...) {
			return E_FAIL;
		}
		return S_OK;
	}
	STDMETHOD(Clear) (void) {
		LOCK_THIS_OBJ
		m_coll.clear();
		return S_OK;
	}
};

OBJECT_ENTRY_AUTO(__uuidof(SVNWcInfoVector), CSVNWcInfoVector)
